using System;
using System.Collections.Generic;
using System.Text;

namespace Uploader
{ /* simple configuration stuff, using registry */
    class Config
    {
        private static Microsoft.Win32.RegistryKey regKeyApp = null;

        public static void Init()
        {
            regKeyApp = Microsoft.Win32.Registry.CurrentUser.CreateSubKey(@"Software\EZFTPUpload");
        }

        public static void End()
        {
            regKeyApp.Flush();
            regKeyApp.Close();
        }

        public static string WebPath
        {
            get
            {
                // ?? = null-coalescing operator
                // value = (x ?? y); if x is null value is y otherwise it is x
                // getvalue returns an object as proper to key type; int, string, etc.
                return AppMain.webPath ?? (string)regKeyApp.GetValue("WebPath") ?? "http://server/path/to/web/directory";
            }
            set
            {
                regKeyApp.SetValue("WebPath", value);
                regKeyApp.Flush(); // apply now
            }

        }
        public static string FtpPath
        {
            get
            {
                return AppMain.ftpPath ?? (string)regKeyApp.GetValue("FtpPath") ?? "ftp://server/goes/here";
            }
            set
            {
                regKeyApp.SetValue("FtpPath", value);
                regKeyApp.Flush();
            }

        }

        public static string UserName
        {
            get
            {
                return (string)regKeyApp.GetValue("UserName") ?? "Anonymous";
            }
            set
            {
                regKeyApp.SetValue("UserName", value);
                regKeyApp.Flush();
            }

        }

        public static string Password
        {
            get
            { // not an awesome encoding, but atleast it's less obvious.
                return Funcs.ROT13P((string)regKeyApp.GetValue("Password")) ?? "";
            }
            set
            {
                regKeyApp.SetValue("Password", Funcs.ROT13P(value));
                regKeyApp.Flush();
            }

        }
    }
}
