using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

/* configuration form */

namespace Uploader
{
    public partial class ConfigForm : Form
    {
        public const string note = "Saved, click to clear.";
        public ConfigForm()
        {
            InitializeComponent();

            textFTPAddr.Text = Config.FtpPath;
            textHTTPAddr.Text = Config.WebPath;
            textUser.Text = Config.UserName;

            if (Config.Password.Length != 0)
                textPass.Text = note;

            textPass.Click += new EventHandler(textPass_Click);

            toolTip.SetToolTip(labelF, "Address of FTP server. Must start with ftp://");
            toolTip.SetToolTip(labelH, "Corresponding web path. (optional)");
            toolTip.SetToolTip(labelU, "Username");
            toolTip.SetToolTip(labelP, "Password. Click to edit");
        }

        void textPass_Click(object sender, EventArgs e)
        {
            textPass.UseSystemPasswordChar = true; // not set initially cos we want them to read our note
            
            if (textPass.Text == note)
                textPass.Text = "";
                
        }

        private void buttCancel_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void buttOK_Click(object sender, EventArgs e)
        {
          
           Config.FtpPath = textFTPAddr.Text;
           Config.WebPath = textHTTPAddr.Text;
           Config.UserName = textUser.Text;

           if (textPass.Text != note)
               Config.Password = textPass.Text;

           Close();
        }
    }
}