using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

/* form to edit pics and then upload them. MS paint beware. */

namespace Uploader
{
    public partial class EditorForm : Form
    {

        public string Filename
        {
            get
            {
                return textName.Text;
            }
            set
            {
                textName.Text = value;
            }
        }

        private UploadForm parent = null;
        private const int maxLineWidth = 8;

        public EditorForm(UploadForm p)
        {
            parent = p;
            InitializeComponent();

            Menu = new MainMenu();

            MenuItem file = new MenuItem("&File");

            Funcs.AddNewMenuItem(file, "&New", new EventHandler(newFile));
            Funcs.AddSeperator(file);
            Funcs.AddNewMenuItem(file, "&Open", new EventHandler(Open), Shortcut.CtrlO);
            Funcs.AddNewMenuItem(file, "&Save as...", new EventHandler(Save),Shortcut.CtrlS);
            Funcs.AddSeperator(file);
            Funcs.AddNewMenuItem(file, "&Upload", new EventHandler(buttUpload_Click));
            Funcs.AddSeperator(file);
            Funcs.AddNewMenuItem(file, "E&xit", new EventHandler(Exit));

            MenuItem edit = new MenuItem("&Edit");

            Funcs.AddNewMenuItem(edit, "&Undo", new EventHandler(Undo), Shortcut.CtrlZ);
            Funcs.AddSeperator(edit);
            Funcs.AddNewMenuItem(edit, "&Copy", new EventHandler(Copy), Shortcut.CtrlC);
            Funcs.AddNewMenuItem(edit, "&Paste", new EventHandler(Paste), Shortcut.CtrlV);

            MenuItem tools = new MenuItem("&Tools");
            Funcs.AddNewMenuItem(tools, "&Colour...", new EventHandler(ColourPicker));
            Funcs.AddNewMenuItem(tools, "&Resize", new EventHandler(DoResize));

            Menu.MenuItems.Add(file);
            Menu.MenuItems.Add(edit);
            Menu.MenuItems.Add(tools);

            toolTip.SetToolTip(buttOpt,"Crop image/change line width");
            toolTip.SetToolTip(buttExit,"Exit");
            toolTip.SetToolTip(buttPaste,"Paste image from clipboard");
            toolTip.SetToolTip(buttUpload,"Upload image to server");
            toolTip.SetToolTip(buttColor, "Select colour");
            toolTip.SetToolTip(buttFmt, "Toggle upload format");
            toolTip.SetToolTip(cbMode, "Select edit mode");

            buttOpt.MouseDown += new MouseEventHandler(option_MouseClick);

            cbMode.SelectedIndex = 0;

            lblDim.Text = "";
            GetImage();

            if ((picEd.Image == null) && System.IO.File.Exists(parent.Filename))
                try {
                    OpenPic(parent.Filename);
                } catch { }         
        }
   
        private void Paste(object sender, EventArgs e)
        {
            GetImage();           
        }
        public Image TakeScreenshot() {
            checked {
                Point startLocation = new Point(0, 0);
                Point endLocation = new Point(0, 0);
                Screen[] screens = Screen.AllScreens;
                Screen[] array = screens;
                bool flag;
                for (int i = 0; i < array.Length; i++) {
                    Screen tempScreen = array[i];
                    Rectangle bounds = tempScreen.Bounds;
                    flag = (bounds.X < startLocation.X);
                    Rectangle bounds2;
                    if (flag) {
                        bounds2 = tempScreen.Bounds;
                        startLocation.X = bounds2.X;
                    }
                    bounds2 = tempScreen.Bounds;
                    flag = (bounds2.Y < startLocation.Y);
                    if (flag) {
                        bounds = tempScreen.Bounds;
                        startLocation.Y = bounds.Y;
                    }
                    bounds2 = tempScreen.Bounds;
                    int arg_BD_0 = bounds2.X;
                    bounds = tempScreen.Bounds;
                    flag = (arg_BD_0 + bounds.Width > endLocation.X);
                    Rectangle bounds3;
                    Rectangle bounds4;
                    if (flag) {
                        bounds3 = tempScreen.Bounds;
                        int arg_EF_0 = bounds3.X;
                        bounds4 = tempScreen.Bounds;
                        endLocation.X = arg_EF_0 + bounds4.Width;
                    }
                    bounds4 = tempScreen.Bounds;
                    int arg_117_0 = bounds4.Y;
                    bounds3 = tempScreen.Bounds;
                    flag = (arg_117_0 + bounds3.Height > endLocation.Y);
                    if (flag) {
                        bounds2 = tempScreen.Bounds;
                        int arg_149_0 = bounds2.Y;
                        bounds = tempScreen.Bounds;
                        endLocation.Y = arg_149_0 + bounds.Height;
                    }
                }
                Bitmap screenGrab = new Bitmap(endLocation.X + Math.Abs(startLocation.X), endLocation.Y + Math.Abs(startLocation.Y));
                Graphics g = Graphics.FromImage(screenGrab);
                Graphics arg_1E1_0 = g;
                int arg_1E1_1 = startLocation.X;
                int arg_1E1_2 = startLocation.Y;
                int arg_1E1_3 = 0;
                int arg_1E1_4 = 0;
                Size blockRegionSize = new Size(endLocation.X + Math.Abs(startLocation.X), endLocation.Y + Math.Abs(startLocation.Y));
                arg_1E1_0.CopyFromScreen(arg_1E1_1, arg_1E1_2, arg_1E1_3, arg_1E1_4, blockRegionSize);
                return screenGrab;
            }
        }


        private void DoResize(object sender, EventArgs e)
        {
            if (picEd.Image != null) {
                ResizeForm r = new ResizeForm(picEd.Image.Height, picEd.Image.Width);
                r.ShowDialog();

                if (r.OK)
                {
                    picEd.DoResize(r.vWidth, r.vHeight);
                    lblDim.Text = picEd.Image.Width + " x " + picEd.Image.Height;
                }
                
            }
        }

        private void newFile(object sender, EventArgs e)
        {
            Rectangle r = Screen.FromPoint(this.Location).Bounds;
            picEd.Image = new Bitmap(r.Width,r.Height);

            lblDim.Text = picEd.Image.Width + " x " + picEd.Image.Height;
            Filename = Funcs.RandomAlphanumeric();
        }

        private void GetImage()
        {
            if (Clipboard.ContainsImage())
            {
                picEd.Image = Clipboard.GetImage();

                lblDim.Text = picEd.Image.Width + " x " + picEd.Image.Height;
                Filename = Funcs.RandomAlphanumeric();
            }
        }

        private void optionClicked(object sender, EventArgs e)
        {
            if (buttOpt.Text == "Crop")
            {
                if (picEd.Image != null)
                {
                    picEd.CropToSelection();
                    lblDim.Text = picEd.Image.Width + " x " + picEd.Image.Height;
                }
            }
            else
            {
                picEd.LineWidth++;

                if (picEd.LineWidth > maxLineWidth)
                    picEd.LineWidth = 1;

                ClearButton();
                UpdateButton();
            }

        }

        void option_MouseClick(object sender, MouseEventArgs e)
        {
            if ((e.Button == MouseButtons.Right) && (buttOpt.Text != "Crop"))
            {
                picEd.LineWidth--;

                if (picEd.LineWidth <= 0)
                    picEd.LineWidth = maxLineWidth;

                ClearButton();
                UpdateButton();
            }
        }

        private void Copy(object sender, EventArgs e)
        {
            lock (picEd.Image)
            {
                if (picEd.Image != null)
                    Clipboard.SetImage(picEd.Image);
            }
        }

        private void buttUpload_Click(object sender, EventArgs e)
        {
            if (buttUpload.Text != "Stop")
            {
                buttUpload.Text = "Stop";

                Thread worker = new Thread(new ThreadStart(DoStartUpload));
                
                worker.IsBackground = true;
                worker.SetApartmentState(ApartmentState.STA);
                worker.Start();
            }
            else
                parent.Stopping = true;
        }

        private void DoStartUpload()
        {

            string name = System.IO.Path.GetTempPath() + Filename + "." + buttFmt.Text;

            if ((picEd.Image != null) && parent.Ready)
            {
                foreach (Control c in this.Controls)
                    c.Enabled = false;

                Menu.MenuItems[0].Enabled = false;
                Menu.MenuItems[1].Enabled = false;
                Menu.MenuItems[2].Enabled = false;

                // move windows around so progress bar is visible.
                bool wasMaximized = (WindowState == FormWindowState.Maximized);
                
                Screen currScr = Screen.FromPoint(this.Location);
                Size PrevSz = Size;
                Point PrevLoc = Location;
                Point parPrevLoc = parent.Location;
                
                int t = (PrevLoc.Y + PrevSz.Height + 100);

                if (wasMaximized)
                {
                    this.WindowState = FormWindowState.Normal;
                    PrevSz = Size; // preserve the normal size

                    this.Location = new Point(PrevLoc.X, 0);
                    this.Size = new Size(currScr.WorkingArea.Width, currScr.WorkingArea.Height - 100);                    
                }
                else if (t > currScr.WorkingArea.Height)
                {
                    int newHeight = PrevLoc.Y - (t - currScr.WorkingArea.Height);
                    if (newHeight < 0) // window too tall
                    {
                        this.Height = Height + newHeight;
                        newHeight = 0;
                    }

                    this.Location = new Point(PrevLoc.X, newHeight);                  
                }

                try
                {

                    lock (picEd.Image)
                    {
                        System.Drawing.Imaging.ImageFormat f = System.Drawing.Imaging.ImageFormat.Png;
                        
                        if (buttFmt.Text == "GIF")
                        {
                            f = System.Drawing.Imaging.ImageFormat.Gif;                       
                        }
                        else if (buttFmt.Text == "JPG")
                            f = System.Drawing.Imaging.ImageFormat.Jpeg;
         
                
                        picEd.Image.Save(name, f);
                    }
                    
                    parent.Filename = name;
                    parent.Location = new Point(Location.X, Location.Y + Height - 80);         
                    
                    parent.TopMost = true;
                    parent.OperationSuccess = false;
                    
                    buttUpload.Enabled = true;

                    parent.Execute();
                    
                    while (!parent.Ready)
                        System.Threading.Thread.Sleep(10);

                }
                catch (Exception ex)
                { 
                    MessageBox.Show("Failure\r\n" + ex.Message, "Upload Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }

                parent.TopMost = false;  
                parent.Filename = "Picture from clipboard...";
                
                if (System.IO.File.Exists(name))
                    System.IO.File.Delete(name);

                // restore last sizes
                parent.Location = parPrevLoc;
                Size = PrevSz;
                Location = PrevLoc;

                if (wasMaximized)
                    this.WindowState = FormWindowState.Maximized;

                foreach (Control c in this.Controls)
                    c.Enabled = true;

                Menu.MenuItems[0].Enabled = true;
                Menu.MenuItems[1].Enabled = true;
                Menu.MenuItems[2].Enabled = true;
            }

            buttUpload.Text = "Upload";
        }

        private void Exit(object sender, EventArgs e)
        {
            this.Close();
            picEd.doDispose();
        }

        private void Save(object sender, EventArgs e)
        {
           
            if (picEd.Image != null)
            {
                saveFileDialog.FileName = Filename + ".png";
                DialogResult d = saveFileDialog.ShowDialog();

                if (d == DialogResult.OK) 
                    try
                    {
                        picEd.Image.Save(saveFileDialog.FileName, saveFileDialog.FileName.EndsWith("png") ? System.Drawing.Imaging.ImageFormat.Png : System.Drawing.Imaging.ImageFormat.Jpeg);
                    }
                    catch
                    {
                        MessageBox.Show("Failed to save\r\n" + saveFileDialog.FileName + "\r\nPlease check that the file is not in use by another program.", "Error saving file", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
            }
        }


        private void ColourPicker(object sender, EventArgs e)
        {
            colorDialog.ShowDialog();
            buttColor.BackColor = colorDialog.Color;
            picEd.EditColour = colorDialog.Color;
            UpdateButton();
        }

        private void toolSelectedChanged(object sender, EventArgs e)
        {
            buttOpt.Text = "";
            buttOpt.Enabled = true;
                    
            switch (cbMode.SelectedIndex)
            {
                case 1: //Frect
                    buttOpt.Enabled = false;
                    buttOpt.Text = "Crop";
                    picEd.Mode = EditorCtrl.EditMode.FillRect;
                    break;
                case 2: //Circle
                    picEd.Mode = EditorCtrl.EditMode.Circle;
                    break;
                case 3: // Line
                    picEd.Mode = EditorCtrl.EditMode.Line;
                    break;
                case 4: // Pencil
                    picEd.Mode = EditorCtrl.EditMode.Pencil;
                    break;

                default:
                    picEd.Mode = EditorCtrl.EditMode.Select;
                    buttOpt.Text = "Crop";
                    break;

            }

            ClearButton();

            if (buttOpt.Text != "Crop")
                UpdateButton();           

            picEd.Reset();
            
        }

        private void ClearButton() // clear image (and dispose of it)
        {
            if (buttOpt.Image != null)
                buttOpt.Image.Dispose();

            buttOpt.Image = null;
        }

        private void UpdateButton()
        {

            buttOpt.Image = new Bitmap(24, picEd.LineWidth);    // create a line showing thickness
            
            Graphics g = Graphics.FromImage(buttOpt.Image);
            g.Clear(picEd.EditColour);                          // fills w/ colour
            g.Dispose();

        }

        private void Undo(object sender, EventArgs e)
        {
            picEd.Undo();
        }

        private void Open(object sender, EventArgs e)
        {
            DialogResult d = openFileDialog.ShowDialog();

                if (d == DialogResult.OK)
                    try
                    {
                        OpenPic(openFileDialog.FileName);
                    }
                    catch
                    {
                        MessageBox.Show(openFileDialog.FileName + " is not a valid image format.", "Error opening file", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                    
        }
        
        private void OpenPic(string s)
        {
            // prevent file-locked stuff
            picEd.Image = Funcs.CleanseImage(new Bitmap(s));

            Filename = s.Substring(s.LastIndexOf("\\")+1);
            Filename = Filename.Substring(0, Filename.LastIndexOf("."));

            lblDim.Text = picEd.Image.Width + " x " + picEd.Image.Height;
        }

        private void buttFmt_Click(object sender, EventArgs e)
        {
            if (buttFmt.Text == "PNG")
            {
                buttFmt.Text = "JPG";
            }
            else if (buttFmt.Text == "JPG")
            {
                buttFmt.Text = "GIF";
            } else
                buttFmt.Text = "PNG";
        }

        private void textName_TextChanged(object sender, EventArgs e)
        {
            int i = textName.SelectionStart;
            Filename = Filename.Replace(" ", "_");
            textName.SelectionStart = i;
        }

        private void button1_Click(object sender, EventArgs e) {
            this.Hide();
            parent.Hide();
            Thread.Sleep(500);
            picEd.Image = TakeScreenshot();
            parent.Show();
            this.Show();

            lblDim.Text = picEd.Image.Width + " x " + picEd.Image.Height;
            Filename = Funcs.RandomAlphanumeric();
        }
    }
}