using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

/* form used to resize picture. could be better, but i got lazy/annoyed */

namespace Uploader
{
    public partial class ResizeForm : Form
    {

        public int vScale
        {
            get
            {
                return (int)nmScale.Value;
            }
        }

        public bool OK = false;

        int iW;
        int iH;

        public int vWidth, vHeight;

        public ResizeForm(int h, int w)
        {
            InitializeComponent();

            iW = w;
            iH = h;

            vWidth = w;
            vHeight = h;

            labelOrig.Text = w + " x " + h;
            labelNew.Text = labelOrig.Text;

            nmScale.ValueChanged += new EventHandler(nmScale_ValueChanged);
            nmScale.KeyPress += new KeyPressEventHandler(nmScale_KeyPress);
            nmScale.LostFocus += new EventHandler(nmScale_ValueChanged);
            nmScale.KeyUp += new KeyEventHandler(nmScale_KeyUp);
            tbScale.ValueChanged += new EventHandler(tbScale_ValueChanged);
        }

        void nmScale_KeyUp(object sender, KeyEventArgs e)
        {
            nmScale_ValueChanged(null, null);
        }

        void nmScale_KeyPress(object sender, KeyPressEventArgs e)
        {
            nmScale_ValueChanged(null, null);
        }


        void tbScale_ValueChanged(object sender, EventArgs e)
        {
            if (tbScale.Value != tbScale.Maximum)
                nmScale.Value = tbScale.Value;

            DoScale();
        }

        void nmScale_ValueChanged(object sender, EventArgs e)
        {
            if (nmScale.Value < tbScale.Maximum)
            {
                tbScale.Value = (int)nmScale.Value;
            }
            else
                tbScale.Value = tbScale.Maximum;

            DoScale();
        }

        void DoScale()
        {
            vHeight = (iH * vScale) / 100;
            vWidth = (iW * vScale) / 100;

            labelNew.Text = vWidth + " x " + vHeight;
        }

        private void buttOK_Click(object sender, EventArgs e)
        {
            OK = true;
            Close();
        }

        private void buttCancel_Click(object sender, EventArgs e)
        {
            Close();
        }


    }
}